require 'src/dependencies'

WINDOW_WIDTH = 1280
WINDOW_HEIGHT = 720

VIRTUAL_WIDTH = 1280
VIRTUAL_HEIGHT = 720

BRUSH_ROWS = 2
BRUSH_SIZE = 64

function love.load()

	math.randomseed(os.time())

	love.window.setTitle('Speed is King')

	love.keyboard.keysPressed = {}
	love.mouse.mouseButtonsPressed = {}
	love.mouse.wheelInput = 0

	push:setupScreen(VIRTUAL_WIDTH, VIRTUAL_HEIGHT, WINDOW_WIDTH, WINDOW_HEIGHT, {
        vsync = true,
        fullscreen = false,
        resizable = true
    })


	gStateMachine = StateMachine({
		['start'] = function() return StartState() end,
		['level-editor'] = function() return LevelEditorState() end,
		['play'] = function() return PlayState() end,
		['test'] = function() return TestState() end
	})
	gStateMachine:change('start')

	debug = ""
end

function love.resize(w, h)
	push:resize(w, h)
end

function love.update(dt)
	gStateMachine.current:update(dt)

	if love.keyboard.wasPressed('escape') then
		love.event.quit()
	end

	love.keyboard.keysPressed = {}
	love.mouse.mouseButtonsPressed = {}
	love.mouse.wheelInput = 0
end

function love.keypressed(key)
	love.keyboard.keysPressed[key] = true
end

function love.keyboard.wasPressed(key)
	return love.keyboard.keysPressed[key]
end

function love.mousepressed(x, y, button)
	love.mouse.mouseButtonsPressed[button] = true
end

function love.mouse.wasPressed(button)
	return love.mouse.mouseButtonsPressed[button]
end

function love.wheelmoved(x, y)
	love.mouse.wheelInput = y
end

function love.draw()
	push:start()

	gStateMachine.current:render()

	love.graphics.setFont(gFonts['default'])
	love.graphics.print(love.timer.getFPS(), 0, 0)

	love.graphics.setColor(255, 255, 255, 255)
		
	push:finish()
end