Brush = Class{}



function Brush:init(x, y, sprite)
	self.x = x
	self.y = y
	self.sprite = sprite

	self.width = BRUSH_SIZE
	self.height = BRUSH_SIZE

	self.scale = {
		x = 1 / (self.sprite:getWidth() / BRUSH_SIZE),
		y = 1 / (self.sprite:getHeight() / BRUSH_SIZE)
	}

	self.bounds = {
		top = self.y,
		right = self.x + BRUSH_SIZE - 1,
		bottom = self.y + BRUSH_SIZE - 1,
		left = self.x
	}

	self.selected = false
end

function Brush:update(dt)

end

function Brush:toggle()
	self.selected = not self.selected
end

function Brush:select()
	self.selected = true
end

function Brush:deselect()
	self.selected = false
end

function Brush:render()
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.draw(self.sprite, self.x, self.y, 0, self.scale.x, self.scale.y)

	love.graphics.setFont(gFonts['default'])
	love.graphics.setColor(0, 100, 100, 255)
	love.graphics.printf(	string.format('%.0fx%.0f', self.sprite:getWidth(), self.sprite:getHeight()), 
							self.x, self.y + BRUSH_SIZE - love.graphics.getFont():getHeight(), BRUSH_SIZE, 'center')
	
	if self.selected then
		love.graphics.setColor(0, 0, 255, 255)
		love.graphics.setLineWidth(1)
		love.graphics.rectangle('line', self.x + 1, self.y, self.width - 1, self.height - 1)
	end
end