StartState = Class{__includes = BaseState}

function StartState:init()
	self.highlighted = 0
end


function StartState:update(dt)
	if love.keyboard.wasPressed('up') then
		self.highlighted = math.max(self.highlighted - 1, 0)
	end

    if love.keyboard.wasPressed('down') then
        self.highlighted = math.min(self.highlighted + 1, 2)
    end

	if love.keyboard.wasPressed('enter') or love.keyboard.wasPressed('return') then
		if self.highlighted == 0 then
			gStateMachine:change('play', 0)
		end
        if self.highlighted == 1 then
			gStateMachine:change('level-editor')
		end
        if self.highlighted == 2 then
            gStateMachine:change('test')
        end
	end
end

function StartState:render()
    love.graphics.setFont(gFonts['title'])
    love.graphics.printf("Speed is King", 0, VIRTUAL_HEIGHT / 3,
        VIRTUAL_WIDTH, 'center')
    
    love.graphics.setFont(gFonts['default-large'])
    if self.highlighted == 0 then
        love.graphics.setColor(103, 255, 255, 255)
    end
    love.graphics.printf("START", 0, VIRTUAL_HEIGHT / 2 + 70,
        VIRTUAL_WIDTH, 'center')

    love.graphics.setColor(255, 255, 255, 255)

    if self.highlighted == 1 then
        love.graphics.setColor(103, 255, 255, 255)
    end
    love.graphics.printf("LEVEL EDITOR", 0, VIRTUAL_HEIGHT / 2 + 120,
        VIRTUAL_WIDTH, 'center')

    love.graphics.setColor(255, 255, 255, 255)

    if self.highlighted == 2 then
        love.graphics.setColor(103, 255, 255, 255)
    end
    love.graphics.printf("TEST", 0, VIRTUAL_HEIGHT / 2 + 170,
        VIRTUAL_WIDTH, 'center')

    love.graphics.setColor(255, 255, 255, 255)
end