TestState = Class{__includes = BaseState}

local INIT_ZOOM = 20.000000
local INIT_TRANSLATION_X = -101
local INIT_TRANSLATION_Y = -593

local keyFrames = {
	[-1] = {zoom = 20, xTrans = -101, yTrans = -593},
	[0] = {zoom = 19, xTrans = -101, yTrans = -592},
	[1] = {zoom = 18, xTrans = -102, yTrans = -589},
	[2] = {zoom = 17, xTrans = -100, yTrans = -587},
	[3] = {zoom = 16, xTrans = -99, yTrans = -584},
	[4] = {zoom = 16, xTrans = -98, yTrans = -584},
	[5] = {zoom = 15, xTrans = -96, yTrans = -583},
	[6] = {zoom = 14, xTrans = -90, yTrans = -582},
	[7] = {zoom = 12, xTrans = -87, yTrans = -577},
	[8] = {zoom = 10, xTrans = -84, yTrans = -570},
	[9] = {zoom = 8, xTrans = -79, yTrans = -562},
	[10] = {zoom = 7, xTrans = -68, yTrans = -554},
	[11] = {zoom = 6, xTrans = -59, yTrans = -543},
	[12] = {zoom = 5, xTrans = -44, yTrans = -526},
	[13] = {zoom = 4, xTrans = -34, yTrans = -495},
	[14] = {zoom = 3, xTrans = -20, yTrans = -456},
	[15] = {zoom = 2, xTrans = 1, yTrans = -365},
	[16] = {zoom = 1, xTrans = 29, yTrans = -17},
}

function TestState:init()
	self.player = Player(64, VIRTUAL_HEIGHT - 128, gSprites['player'])
	self.animStartTime = love.timer.getTime()
	self.time = self.animStartTime
	self.zoom = INIT_ZOOM
	self.translation = {x = INIT_TRANSLATION_X, y = INIT_TRANSLATION_Y}
	self.lastMousePos = {}
	self.mode = 'edit'
	self.keyFrame = 0
end

function TestState:update(dt)

	if self.mode == 'edit' then
		if love.mouse.wheelInput ~= 0 then
			self.zoom = clamp(self.zoom + love.mouse.wheelInput, 1, 40)
		end

		if love.mouse.isDown(1) then
			self.translation.x = self.translation.x + (love.mouse.getX() - self.lastMousePos.x) / self.zoom
			self.translation.y = self.translation.y + (love.mouse.getY() - self.lastMousePos.y) / self.zoom
		end

		self.lastMousePos = {x = love.mouse.getX(), y = love.mouse.getY()}

		if love.keyboard.wasPressed('return') then
			love.filesystem.setIdentity('Speed is King/zooms')

			love.filesystem.append('zooms.txt', string.format(	'['..#keyFrames..'] = {'..
																'zoom = %.0f, xTrans = %.0f, yTrans = %.0f},\n',
																self.zoom, self.translation.x, self.translation.y))
		end
	end

	if self.mode == 'test' then
		if self.keyFrame < 17 then
			self.zoom = approach(self.zoom, (keyFrames[self.keyFrame].zoom - keyFrames[self.keyFrame-1].zoom) * dt / 1, keyFrames[self.keyFrame].zoom)
			self.translation.x = approach(self.translation.x, (keyFrames[self.keyFrame].xTrans - keyFrames[self.keyFrame-1].xTrans) * dt / 1, keyFrames[self.keyFrame].xTrans)
			self.translation.y = approach(self.translation.y, (keyFrames[self.keyFrame].yTrans - keyFrames[self.keyFrame-1].yTrans) * dt / 1, keyFrames[self.keyFrame].yTrans)
			self.time = self.time + dt
			if self.time - self.animStartTime > 1 then
				self.keyFrame = self.keyFrame + 1
				self.animStartTime = self.time
			end
		end
	end

	if love.keyboard.wasPressed('space') then
		self.mode = self.mode == 'edit' and 'test' or 'edit'
	end

	debug = string.format('%.0f\n%.2f %.2f', self.zoom, self.translation.x, self.translation.y)
end

function TestState:render()
	love.graphics.push()


		love.graphics.scale(self.zoom, self.zoom)
		love.graphics.translate(self.translation.x, self.translation.y)

		self.player:render(0.25)

	love.graphics.pop()

	love.graphics.print(debug, 10, 100)
end