TestState = Class{__includes = BaseState}

local zoom = 1
local cameraPos = {x = 640, y = 360}

local mouseZoomPos = {x = 0, y = 0}

local lastMousePos = {x = 0, y = 0}

local mode = 'free'

local t = 0

function TestState:init()

end

function TestState:update(dt)

	if love.keyboard.wasPressed('space') then
		mode = mode == 'free' and 'cinematic' or 'free'
		t = 0
	end

	if mode == 'free' then
		if love.mouse.wheelInput ~= 0 then
			--mouseZoomPos = {x = (love.mouse.getX() - 640) / zoom + cameraPos.x, 
			--				y = (love.mouse.getY() - 360) / zoom + cameraPos.y}
			--cameraPos = {x = mouseZoomPos.x, y = mouseZoomPos.y}
			zoom = zoom * 2 ^ love.mouse.wheelInput
		end

		if love.mouse.isDown(1) then
			cameraPos = {x = cameraPos.x - (love.mouse.getX() - lastMousePos.x) / zoom, y = cameraPos.y - (love.mouse.getY() - lastMousePos.y) / zoom}
		end

		lastMousePos = {x = love.mouse.getX(), y = love.mouse.getY()}
	end

	if mode == 'cinematic' then
		zoom = math.sqrt(zoom) - dt
		cameraPos = {x = cameraPos.x + dt, y = cameraPos.y - dt}
	end

	debug = string.format('%.0f\n%.0f %.0f', zoom, love.mouse.getX(), love.mouse.getY())
end

function TestState:render()
	love.graphics.push()

	love.graphics.scale(zoom, zoom)
	love.graphics.translate(640 / zoom - cameraPos.x, 360 / zoom - cameraPos.y)

	love.graphics.draw(gSprites['background'], 0, 0)

	love.graphics.pop()

	love.graphics.print(debug, 10, 100)
end



